tableau liste projets
<!-- TODO: add role display view control -->
<div class="table-header container-fluid d-flex ">
  <div class="table-title container-fluid d-flex align-items-center">
    <app-add-projet-popup ></app-add-projet-popup>
    <h1 class="text-grey">Projets</h1>
  </div>
</div>
<!--Add the search bar-->
  <div class="ms-4 mb-2" >
    <form class="d-flex"   >
      <input (ngModelChange)="search(key.value)" #key="ngModel" ngModel name="key" class="form-control me-2" type="search" placeholder="Search" aria-label="Search">
    </form>
</div>

<div class="table-container table-responsive">
  <table class="table table p-3 text-grey">
    <caption>Tableau de la liste des projets</caption>
    <thead id="table-titles">
    <tr>
      <th class="center sm" scope="col">#</th>
      <th scope="col">Intitulé</th>
      <th scope="col">Détails</th>
      <th class="center sm" scope="col">Version</th>
      <th class="center sm" scope="col">Aperçu</th>
      <th class="center sm" scope="col">Editer</th>
      <th class="center sm" scope="col">Archiver</th>
    </tr>
    </thead>
    <tbody>
    <tr  *ngFor="let projet of storedProjets"
         id="{{ projet?.id }}">
      <th class="center sm text-grey" scope="row">{{ projet?.id }}</th>
      <td class="text-grey"
          (click)="redirect(projet)"
          style="cursor: pointer;">
        {{ projet?.nom }}</td>
      <td class="text-grey"
          (click)="redirect(projet)"
          style="cursor: pointer;">
        {{ projet.details }}</td>
      <td class="center sm text-grey edit-version-projet" style="cursor: pointer;" (click)="onEditVersion($event, projet)">{{ projet?.version }}</td>
      <td id="aperçu{{ projet?.id }}"
          style="cursor: pointer;font-weight: bold;"
          class="center sm text-grey">
        <svg id="edit-icon-projet" (click)="onClick($event, projet)" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512">
          <g>
            <g fill="#231F20">
              <path d="m34,256l26.2,26.2c108,108 283.7,108 391.7,0l26.1-26.2-26.2-26.2c-108-108-283.7-108-391.7,0l-26.1,26.2zm222,126.2c-75.8,0-151.6-28.9-209.3-86.6l-32.9-32.9c-3.7-3.7-3.7-9.7 0-13.5l32.9-32.9c115.4-115.4 303.2-115.4 418.6,0l32.9,32.9c3.7,3.7 3.7,9.7 0,13.5l-32.9,32.9c-57.7,57.7-133.5,86.6-209.3,86.6z"/>
              <path d="m256,183.5c-40,0-72.5,32.5-72.5,72.5s32.5,72.5 72.5,72.5c40,0 72.5-32.5 72.5-72.5s-32.5-72.5-72.5-72.5zm0,164c-50.5,0-91.5-41.1-91.5-91.5 0-50.5 41.1-91.5 91.5-91.5s91.5,41.1 91.5,91.5c0,50.5-41,91.5-91.5,91.5z"/>
            </g>
          </g>
        </svg>
      </td>
      <td id="edit{{ projet?.id }}}"
          style="cursor: pointer;font-weight: bold;"
          class="center sm text-grey">
        <i (click)="onEdit($event, projet)" aria-hidden="true" class="fa-solid fa-pen edit-projet"></i>
      </td>
      <td id="delete{{ projet?.id }}"
          style="cursor: pointer;font-weight: bold;"
          class="center sm text-grey">
        <svg *ngIf="!projet.archive" (click)="onDelete($event, projet)" id="deleteIcon" xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="122.878px" height="122.88px" viewBox="0 0 122.878 122.88"  xml:space="preserve"><g><path d="M1.426,8.313c-1.901-1.901-1.901-4.984,0-6.886c1.901-1.902,4.984-1.902,6.886,0l53.127,53.127l53.127-53.127 c1.901-1.902,4.984-1.902,6.887,0c1.901,1.901,1.901,4.985,0,6.886L68.324,61.439l53.128,53.128c1.901,1.901,1.901,4.984,0,6.886 c-1.902,1.902-4.985,1.902-6.887,0L61.438,68.326L8.312,121.453c-1.901,1.902-4.984,1.902-6.886,0 c-1.901-1.901-1.901-4.984,0-6.886l53.127-53.128L1.426,8.313L1.426,8.313z"/></g></svg>
        <svg *ngIf="projet.archive" (click)="onDelete($event, projet)" id="deleteIcon" data-name="Layer 1" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 112.62 120.72"><title>circle arrow</title><path d="M11.64,100.12l-.4-.47-1.06,8.63a5.08,5.08,0,0,1-1.92,3.41A5.11,5.11,0,0,1,0,107L2.79,84.65v-.07a3.28,3.28,0,0,1,.08-.41h0A5.09,5.09,0,0,1,9,80.39q11.22,2.53,22.42,5.15a5,5,0,0,1,3.17,2.25,5.14,5.14,0,0,1,.64,3.84v0a5,5,0,0,1-2.25,3.16,5.08,5.08,0,0,1-3.83.65c-3.31-.75-6.62-1.52-9.92-2.28a40.71,40.71,0,0,0,2.84,3,50.09,50.09,0,0,0,26.23,13.49,48.67,48.67,0,0,0,14.71.34A47.35,47.35,0,0,0,77,106h0q2.52-1.19,4.83-2.54c1.56-.93,3.07-1.92,4.51-3a50.8,50.8,0,0,0,8.56-7.88,48.92,48.92,0,0,0,6.39-9.45l.56-1.1,10,2.69-.8,1.66a58.64,58.64,0,0,1-7.9,12.24,61.28,61.28,0,0,1-10.81,10.1c-1.68,1.23-3.46,2.4-5.32,3.5s-3.73,2.07-5.74,3a58,58,0,0,1-17,5,58.56,58.56,0,0,1-17.79-.39,60.21,60.21,0,0,1-31.58-16.26c-1.2-1.16-2.26-2.31-3.24-3.45ZM101,20.6l.4.47,1-8.63a5.11,5.11,0,1,1,10.14,1.26l-2.74,22.37,0,.07c0,.13,0,.27-.07.41h0a5.09,5.09,0,0,1-6.08,3.78c-7.47-1.69-15-3.4-22.42-5.15a5,5,0,0,1-3.16-2.25,5.1,5.1,0,0,1-.65-3.84v0a5,5,0,0,1,2.25-3.16,5.1,5.1,0,0,1,3.84-.65c3.31.75,6.61,1.52,9.92,2.28-.84-1-1.77-2-2.84-3.05a50.09,50.09,0,0,0-12.13-8.73A49.49,49.49,0,0,0,64.37,11a48.6,48.6,0,0,0-14.7-.34,47.26,47.26,0,0,0-14,4.1h0q-2.53,1.18-4.83,2.54c-1.57.93-3.07,1.92-4.52,3a50.34,50.34,0,0,0-8.55,7.88,48,48,0,0,0-6.39,9.45l-.57,1.1L.76,36l.8-1.66A58.9,58.9,0,0,1,9.46,22.1,61.63,61.63,0,0,1,20.27,12q2.54-1.85,5.32-3.5c1.81-1.06,3.73-2.07,5.74-3a58,58,0,0,1,17-5A58.56,58.56,0,0,1,66.16.89a59.77,59.77,0,0,1,17,5.74A60.4,60.4,0,0,1,97.75,17.15c1.19,1.16,2.26,2.31,3.24,3.45Z"/></svg>
      </td>
    </tr>
    <tr *ngIf="!storedProjets?.length">
      <td colspan="5" style="text-align: center">Aucun projet à afficher</td>
    </tr>
    </tbody>
  </table>
</div>
<!-- Modal Projet -->
<div class="modal" id="myModalProjet" [style.display]="showModalProjet ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Détails du Projet :</h4>
        <button type="button"
                class="close"
                data-dismiss="modal"
                (click) = "hide('projet')">
          &times;
        </button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <p>Projet Id : {{ projetId }}</p>
        <p>Intitulé : {{ projetNom }}</p>
        <p>Détails : {{ projetDetails }}</p>
        <p>Version : {{ projetVersion }}</p>
        <!--
        <p>Version : {{ planProjet.version }}</p>
        -->
      </div>
      <!-- Modal footer -->
      <div class="modal-footer">
        <button type="button"
                class="btn btn-danger"
                data-dismiss="modal"
                (click) = "hide('projet')">
          Close
        </button>
      </div>
    </div>
  </div>
</div>

<!-- Modal EDIT projet-->
<div class="modal" id="editModal" [style.display]="showEditModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Détails du Projet : {{editProjet?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('editModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #editForm="ngForm" >
          <div class="form-group">
            <input
              type="hidden"
              ngModel="{{editProjet?.id}}"
              name="id"
              id="id"
            />
            <input
              type="hidden"
              ngModel="{{editProjet?.version}}"
              id="version"
              name="version"
              class="form-control mb-2"
            />
            <label class="mb-1" for="nom">Intitulé</label>
            <input
              type="text"
              ngModel="{{editProjet?.nom}}"
              id="nom"
              name="nom"
              class="form-control mb-2"
            />
          </div>
          <div class="form-group">
            <label class="mb-1" for="details">Détails</label>
            <textarea
              class="form-control mb-2"
              ngModel="{{editProjet?.details}}"
              id="details"
              name="details"
            ></textarea>
          </div>
          <div class="mt-3 mb-2">
            <button class="btn btn-primary w-100" (click)="onSubmit(editForm.value)" [disabled]="editForm.invalid">Sauvegarder</button>
          </div>
          <div class="mt-2 mb-2">
            <button class="btn btn-secondary w-100" type="reset" (click)="hide('editModal')">Annuler</button>
          </div>
        </form>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>



<!-- Modal EDIT projet version-->
<div class="modal" id="editVersionModal" [style.display]="showEditVersionModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Détails du Plan de Tests : {{editProjet?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click) = "hide('editVersionModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <form #editVersionForm="ngForm" >
          <div class="form-group">
            <input
              type="hidden"
              ngModel="{{editVersionProjet?.id}}"
              name="id"
              id="id"
            />
            <input
              type="hidden"
              ngModel="{{editVersionProjet?.nom}}"
              id="nom"
              name="nom"
              class="form-control mb-2"
            />
          </div>
          <div class="form-group">
            <input
              type="hidden"
              ngModel="{{editVersionProjet?.details}}"
              id="details"
              name="details"
              class="form-control mb-2"
            />
          </div>
          <div class="form-group">
            <label class="mb-1" for="details">Modifier Version</label>
            <input
              type="text"
              ngModel="{{editVersionProjet?.version}}"
              id="version"
              name="version"
              class="form-control mb-2"
            />
          </div>
          <div class="mt-3 mb-2">
            <button class="btn btn-primary w-100" (click)="onSaveNewVersion(editVersionForm.value)" [disabled]="editVersionForm.invalid">Sauvegarder</button>
          </div>
          <div class="mt-2 mb-2">
            <button class="btn btn-secondary w-100" type="reset" (click)="hide('editVersionModal')">Annuler</button>
          </div>
        </form>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>

<!-- Modal DELETE Plan-->
<div class="modal" id="deleteModal" [style.display]="showDeleteModal ? 'block' : 'none'">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Archiver : {{deleteProjet?.nom}}</h4>
        <!-- Modal footer -->
        <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="hide('deleteModal')">X</button>
      </div>
      <!-- Modal body -->
      <div class="modal-body">
        <div class="form-group">
          <p *ngIf="deleteProjet?.archive == true" class="mt-3 mb-5" >Vous êtes sur le point de désarchiver le plan de test {{deleteProjet?.nom}}. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
          <p *ngIf="deleteProjet?.archive == false" class="mt-3 mb-5" >Vous êtes sur le point d'archiver le plan de test {{deleteProjet?.nom}}. <br/><br/>
            Êtes-vous sûr.e de vouloir continuer ?</p>
        </div>
        <div class="mt-3 mb-2">
          <button *ngIf="deleteProjet?.archive == true" class="btn btn-danger w-100" (click)="onArchiveProjet(deleteProjet)" data-dismiss="modal">Activer</button>
          <button *ngIf="deleteProjet?.archive == false" class="btn btn-danger w-100" (click)="onArchiveProjet(deleteProjet)" data-dismiss="modal">Désactiver</button>
        </div>
      </div>
      <div class="modal-footer">
        <p *ngIf="isValid" style="text-align:center; color:green; font-weight: bold; " >{{infoMessage}}</p>
        <p *ngIf="!isValid" style="text-align:center; color:red; font-weight: bold " >{{infoMessage}}</p>
      </div>
    </div>
  </div>
</div>
